/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef INITNG_PLUGIN
#define INITNG_PLUGIN
#include "initng_plugin_type.h"
#include "initng_system_states.h"
#include "initng_poll.h"
#include <stdarg.h>
typedef union
{
    int (*hook) (va_list list);
    void *(*phook) (va_list list);
    service_h *(*parser) (char *to_parse);
    void (*watcher) (active_h * service);
    void (*swatcher) (h_sys_state state);
    void (*pipewatcher) (active_h * service, int datalen, process_h * process,
                         int forceflush);
    int (*launcher) (active_h * service);
    int (*af_launcher) (active_h * service, process_h * process);
    int (*handle_killed) (active_h * service, process_h * process);
    void (*main) (void);
    f_module_h fdh;
} uc;

typedef struct
{
    e_ptype ptype;
    uc c;
} s_callers;
#endif
